#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum EnumUnionOperation {
    /// Throws an exception if two series contain points with a duplicate timestamp.
    #[serde(rename = "THROW")]
    Throw,
    /// Aggregates duplicates by String MAX.
    #[serde(rename = "MAX")]
    Max,
    /// Aggregates duplicates by String MIN.
    #[serde(rename = "MIN")]
    Min,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl EnumUnionOperation {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            EnumUnionOperation::Throw => "THROW",
            EnumUnionOperation::Max => "MAX",
            EnumUnionOperation::Min => "MIN",
            EnumUnionOperation::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for EnumUnionOperation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for EnumUnionOperation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for EnumUnionOperation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<EnumUnionOperation, conjure_object::plain::ParseEnumError> {
        match v {
            "THROW" => Ok(EnumUnionOperation::Throw),
            "MAX" => Ok(EnumUnionOperation::Max),
            "MIN" => Ok(EnumUnionOperation::Min),
            v => v.parse().map(|v| EnumUnionOperation::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for EnumUnionOperation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<EnumUnionOperation, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the EnumUnionOperation enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
